#include "neuroninterz.h"

NeuronInterz::NeuronInterz()
{

// 	maxSynapses			= 150;

	isInhibitory			= false;

	// input weight range, 5 = -5 <-> +5	-> 10 in total because 0 will be excluded
// 	dendridicBranches		= 10;

	// processing
// 	firingThreshold			= 30.0f;
	potential			= 0.0f;
//	potentialDecay			= 0.95f;
		// 			^^^ hi just adjust and pass this in brainz outside of
		//			    the loop in process() that calls neuron process()
		//			    to save doing it and energy separately in each
		//			    neuron unless there is some reason you have to
		//			    do drugs between decay and food energy

	// output
	output				= 0;
	waitoutput			= 0;

	// plasticity up & down
	isPlastic			= false;
// 	plasticityStrengthen		= 1.0f+(1.0f/100.0f);
// 	plasticityWeaken		= 1.0f-(1.0f/1000.0f);

	// SPECIALO optional reference that makes this a MOTOR neuron, but it depends on not being defined
	isMotor				= false;
	motorFunc			= 0;

        settings = Settings::Instance();	
	pill_maxtrip = settings->getCVarPtr("pill_maxtrip");
}

void NeuronInterz::process(float potentialDecay, float* tripping, Circuit8* circuit8, unsigned int RuRdGuGdBuBd, unsigned int screenOffsetX, unsigned int screenOffsetY)
//void NeuronInterz::process(float* tripping, Circuit8* circuit8, unsigned int RuRdGuGdBuBd, unsigned int screenOffsetX, unsigned int screenOffsetY)
//float NeuronInterz::process(float* tripping, Circuit8* circuit8, unsigned int RuRdGuGdBuBd, unsigned int screenOffsetX, unsigned int screenOffsetY)
{
//	if (tripping != 0) {
//		printf("tripping value is %f\n",tripping);
//		}
	// potential decay
	potential = potential * potentialDecay;

//	cout << "neuroni energy "<< energy << endl;

//	cout << "neuroni " << circuit8->screenidx << endl;

	// morphogenic field (first area of screen) effect per neuron
//	if (potential < -100000.0f || potential > 100000.0f || potential != potential) { cout << "pathological potential before morphic read (nan?): "<< potential << endl; }

// debug

//	float oldpotential = potential; // preserve potential against morphic breakage

//	if (potential != potential) {
//		cerr << "morphic break down at start of neuron interz. potential had nan in it, setting to 1.0f" << endl;
//		potential = 1.0f;
//		oldpotential = 1.0f;
//	}

// end debug

	if (RuRdGuGdBuBd == 0)      { potential += circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] / 100.0f; }
//	else if (RuRdGuGdBuBd == 1) { potential -= circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] / 100.0f; }
	else if (RuRdGuGdBuBd == 1) { potential += circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] / 100.0f; }
	// ^ red is "warm" now
	else if (RuRdGuGdBuBd == 2) { potential += circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] / 100.0f; }
	else if (RuRdGuGdBuBd == 3) { potential -= circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] / 100.0f; }
//	else if (RuRdGuGdBuBd == 4) { potential += circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] / 100.0f; }
	else if (RuRdGuGdBuBd == 4) { potential -= circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] / 100.0f; }
	// ^ blue is "cool" now
	else if (RuRdGuGdBuBd == 5) { potential -= circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] / 100.0f; }

//	if (potential < -100000.0f || potential > 100000.0f || potential != potential) { cout << "pathological potential after morphic read (nan?): "<< potential << endl; }

	// debugging may still need
//	if (circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] != circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] || circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] < 0 || circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] > 1.0f) {  cout << "bad (nan?) r value " << circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] << endl; }
//	if (circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] != circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] || circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] < 0 || circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] > 1.0f) {  cout << "bad (nan?) g value " << circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] << endl; }
//	if (circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] != circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] || circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] < 0 || circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] > 1.0f) {  cout << "bad (nan?) b value " << circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] << endl; }

	
/*	if (potential != potential) {
		cerr << "morphic break down at start of neuron interz. screen had nan in it, resetting channel. fix me christ" << endl;
		potential = oldpotential;
		if (RuRdGuGdBuBd == 0) { circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] = 0; }
		else if (RuRdGuGdBuBd == 1) { circuit8->screen.screen[screenOffsetX][screenOffsetY].r[circuit8->screenidx] = 1.0f; }
		else if (RuRdGuGdBuBd == 2) { circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] = 0; }
		else if (RuRdGuGdBuBd == 3) { circuit8->screen.screen[screenOffsetX][screenOffsetY].g[circuit8->screenidx] = 1.0f; }
		else if (RuRdGuGdBuBd == 4) { circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] = 0; }
		else if (RuRdGuGdBuBd == 5) { circuit8->screen.screen[screenOffsetX][screenOffsetY].b[circuit8->screenidx] = 1.0f; }
	}  */

	// end debugging

	RuRdGuGdBuBd += 1;

	// make every connection do it's influence on the neuron's total potential
	ssize = Synapses.size();
	for ( i=0; i < ssize; i++ )
	{
//		cout << "neuron influenced by synapse " << i << " out of " << ssize << endl;
		// lower synaptic weights
		if (isPlastic) {
//			cout << "synapse was plastic, " << endl;
//			cout << "weight is " << Synapses[i].weight << endl;
			Synapses[i].weight = Synapses[i].weight * plasticityWeaken;
		}

//		cout << "crash here probably means the synapse is connected to an inexistent neuron id" << endl;
		
		if ( *Synapses[i].ref != 0 ) {
//			cout << "Synapses[i].ref != 0" << endl;
			potential += (Synapses[i].weight * Synapses[i].dendriteBranch * *Synapses[i].ref);
		}
	}

//	cout << "checking inhibitory/excitatory" << endl;

//	float alien_ai_fleet_seed;  // fleet seed not needed now that i'm not somehow smashing tripping[] x_X
	if ( isInhibitory )
	{
//		cout << "neuron is inhib" << endl;

		if (tripping[1]) { // inhibitory agonism
//			alien_ai_fleet_seed = tripping[1];
//			potential = potential - (tripping[1] / (1000.0f - ((tripping[4] / *pill_maxtrip)*1000.0f)));
//			cout << potential << "...";
//			potential = potential * ( 1.0f+((tripping[1]/100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip) * 9.0f)) );
			if (potential < 0) { 
				potential = potential * ( 1.0f+((tripping[1] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			} else {
				potential = potential * ( 1.0f-((tripping[1] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			}
//			cout << "iag * " << ( 1.0f+((tripping[1] / 100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) ) << " = " << potential << endl;
//			tripping[1] = alien_ai_fleet_seed;                // whats happening to value of tripping that i need to do this (flamoot)
		}


		if (tripping[0]) { // inhibitory antagonism
//			alien_ai_fleet_seed = tripping[0];
//			potential = potential * (1 - (tripping[0] / (10000.0f - ((tripping[4] / *pill_maxtrip)*10000.0f))));
//			cout << potential << "...";
//			potential = potential * ( 1.0f-((tripping[0]/100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip) * 9.0f)) );
//			if (potential > 0) { potential = 0; }
			if (potential > 0) { 
				potential = potential * ( 1.0f+((tripping[0] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			} else {
				potential = potential * ( 1.0f-((tripping[0] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			}
//			cout << "ian * "<< ( 1.0f-((tripping[0] / 100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) ) << " = " << potential << endl;
//			tripping[0] = alien_ai_fleet_seed;
		}

//		cout << "would have mionused "<<energy<<" to "<<potential<< " potential" << endl;
		// give them some potential if they're well fed
//		potential -= energy;

//		printf("tripping %f %f\n",tripping,potential);
//		cout << "I" << potential << "\n";

		// do we spike/fire
		if ( potential <= -1.0f * firingThreshold )
		{
			// reset neural potential
			potential = 0.0f;
	
			// fire the neuron
			waitoutput = -1;
			
//			cout << "neuron fires" << endl;

			// PLASTICITY: if neuron & synapse fire together, the synapse strenghtens
			if (isPlastic)
			{
				for ( i=0; i < ssize; i++ )
				{
//					cout << "synapse " << i << " of " << ssize << " is plastic inhib" << endl;
					// if synapse fired, strenghten the weight
					if ( (*Synapses[i].ref < 0.0f && Synapses[i].weight > 0.0f) || (*Synapses[i].ref > 0.0f && Synapses[i].weight < 0.0f) )
					{
// 						cerr << endl << "Inhibitory firing" << endl << "synref: " << *Synapses[i].ref << endl << "pre weight:  " << Synapses[i].weight << endl;
						Synapses[i].weight = Synapses[i].weight * plasticityStrengthen;
// 						cerr << "post weight: " << Synapses[i].weight << endl;
					}

					// if weight > max back to max
 					if	( Synapses[i].weight > 5.0f ) Synapses[i].weight = 5.0f;
 					else if ( Synapses[i].weight <-5.0f ) Synapses[i].weight =-5.0f;
				}
			}
		}
		// don't fire the neuron
		else
		{
			waitoutput = 0;
			// reset potential if < 0
			if ( potential > 0.0f ) potential = 0.0f;
		}
	}
	else
	{
//		cout << "neuron is excitatory" << endl;

		if (tripping[3]) { // excitatory agonism
//			alien_ai_fleet_seed = tripping[3];
//			cout << potential << "...";
			if (potential < 0) { 
				potential = potential * ( 1.0f-((tripping[3] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			} else {
				potential = potential * ( 1.0f+((tripping[3] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			}
//			cout << "eag * " << ( 1.0f+((tripping[3] / 100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) ) << " = " << potential << endl;
//			tripping[3] = alien_ai_fleet_seed;
		}


		if (tripping[2]) { // excitatory antagonism
//			alien_ai_fleet_seed = tripping[2];
//			cout << potential << "...";
//			potential = potential * ( 1.0f-((tripping[2] / 100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
//			if (potential < 0) { potential = 0; }
			if (potential > 0) { 
				potential = potential * ( 1.0f-((tripping[2] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			} else {
				potential = potential * ( 1.0f+((tripping[2] / *pill_maxtrip) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) );
			}

//			cout << "ean * " << ( 1.0f-((tripping[2] / 100000.0f) * (1.0f+(tripping[4] / *pill_maxtrip)*9.0f)) )<< " = "<< potential << endl;
//			tripping[2] = alien_ai_fleet_seed;
		}		

		
//		cout << "would have added "<<energy<<" to "<<potential<< " potential" << endl;
				     // give them some potential if they're well fed
//		potential += energy; // with effect of inhib ag at potentials > 0 and excit ag at < 0,
				     // this may cause firing... otherwise we could remove those
				     // effects, and opposite effects for antags which just make
				     // this less likely to cause firing
				     // all potentials on the wrong side of 0 get reset at the
				     // end of this function anyway
				     // good luck
// redundant now see potentialDecay (passed) ****		

//		printf("tripping %f %f\n",tripping,potential);
//		cout << "E" << potential << "\n";

		// do we spike/fire
		if ( potential >= firingThreshold )
		{
			// reset neural potential
			potential = 0.0f;
	
			// fire the neuron
			waitoutput = 1;
			
//			cout << "neuron fires" << endl;

			// PLASTICITY: if neuron & synapse fire together, the synapse strenghtens
			if (isPlastic)
			{
				for ( i=0; i < ssize; i++ )
				{
//					cout << "synapse " << i << " of " << ssize << " is excit plastic" << endl;
					// if synapse fired, strenghten the weight
					if ( (*Synapses[i].ref > 0.0f && Synapses[i].weight > 0.0f) || (*Synapses[i].ref < 0.0f && Synapses[i].weight < 0.0f) )
					{
// 						cerr << endl << "Excititory firing" << endl << "synref: " << *Synapses[i].ref << endl << "pre weight:  " << Synapses[i].weight << endl;
						Synapses[i].weight = Synapses[i].weight * plasticityStrengthen;
// 						cerr << "post weight: " << Synapses[i].weight << endl;
					}

					// if weight > max back to max
 					if	( Synapses[i].weight > 5.0f ) Synapses[i].weight = 5.0f;
 					else if ( Synapses[i].weight <-5.0f ) Synapses[i].weight =-5.0f;
				}
			}
		}
		// don't fire the neuron
		else
		{
			waitoutput = 0;
			// reset potential if < 0
			if ( potential < 0.0f ) potential = 0.0f;
		}
		//if (tripping) { tripping -= 0.00001f; }
	}
	// neuron effect on morphogenic field (first area of screen)
	
//	cout << "finished synapses" << endl;
	
/*	if (potential != potential) {
		cerr << "morphic field or brain break down at end of neuroninterz... potential was nan'd before morphic writeback. resetting to " << oldpotential << endl;
		potential = oldpotential;
		if (potential != potential) { // no
			potential = 1.0f;
			cerr << "had to set it to one oldpotential was also nan" << endl;
		}
	} */

//	morphic_writeback = abs(potential) / 1048576.0f;  // at 1048576.0, if potential exceeds 500, there will only be one
	morphic_writeback = abs(potential) / 131072.0f;	  // value they can morphically write (.0005f)
							  // but this should never happen
							  // if i never see thresholds exceed 100 I can divide this by 5 or
							  // go back to 50000.0f though this means neurons w/ potentials of 
							  // 25 or > will all map the same regardless of actual potential
							  // this seems too faint, let's use ~100k ... with a limit of
							  // .0009f this should allow potentials of up to 100 to map
							  // distinctly and is only twice as slow as the original 50k
							  // which seemed ok already honestly
							  // oh just make a CVAR for this... with limit at 9f instead of
							  // 5f, dividing by 50k (or 64k I guess) will allow potentials 
							  // up to 60 to map distinctly... potentials of 1 will only
							  // add 0.00001 which is little enough already. 60 is a high
							  // potential really but if I see thresholds above that
							  // appearing, I'll make this configurable or bump it up again
							  // using twice 64k -- 128k -- and the old limit of .0005f (9f
							  // seems too fast...) should still allow potentials up to ~66
							  // to map at different speeds without being crazy loud or
							  // totally silent... this is around 3x slower than originally
//	morphic_writeback = abs(potential) / 65536.0f;							  
//	morphic_writeback = abs(potential) / 50000.0f;							  

							  
//	morphic_writeback = ((unsigned int) abs(potential)) >> 17;
	
//	if (morphic_writeback > .0009f) { morphic_writeback = .0009f; } else if (morphic_writeback <= 0) { morphic_writeback = 0; }  // debug
	if (morphic_writeback > .0006f) { morphic_writeback = .0006f; } else if (morphic_writeback <= 0) { morphic_writeback = 0; }  // debug

//	if (morphic_writeback != morphic_writeback) { cout << "morphic_writeback is nan?!?: mw = "<< morphic_writeback << ", potential = " << potential << endl; morphic_writeback = 0; }

	// never get a morphic field blow-up with no-signed-zeroes CXXFLAG... is -0 < 0? use <= i guess

	if (RuRdGuGdBuBd == 1) { circuit8->lessRed(screenOffsetX, screenOffsetY, morphic_writeback); }
	else if (RuRdGuGdBuBd == 2) { circuit8->moreGreen(screenOffsetX, screenOffsetY, morphic_writeback); }
	else if (RuRdGuGdBuBd == 3) { circuit8->lessGreen(screenOffsetX, screenOffsetY, morphic_writeback); }
	else if (RuRdGuGdBuBd == 4) { circuit8->moreBlue(screenOffsetX, screenOffsetY, morphic_writeback); }
	else if (RuRdGuGdBuBd == 5) { circuit8->lessBlue(screenOffsetX, screenOffsetY, morphic_writeback); }
	else if (RuRdGuGdBuBd == 0 || RuRdGuGdBuBd == 6) { circuit8->moreRed(screenOffsetX, screenOffsetY, morphic_writeback); }

//	return tripping; // unchanged anyway and is a vector now so i dont know how anymore
//	return potential; // testing
//	cout << "neuroni energy @ exit "<< energy << endl;

}

void NeuronInterz::connec( float *output, unsigned int dendriteBranch, float synapticWeight )
//void NeuronInterz::connec( int *output, unsigned int dendriteBranch, float synapticWeight )
{
		Synapse s;
		s.ref = output;
		s.dendriteBranch = dendriteBranch;
		s.weight = synapticWeight;

		Synapses.push_back( s );

//		cerr << "I: " << Synapses.size()-1 << "=" << *Synapses[Synapses.size()-1].ref << "(" << Synapses[Synapses.size()-1].ref << ")";
//		cerr << *Synapses[0].ref << endl;
}

NeuronInterz::~NeuronInterz()
{
//	for ( unsigned int i=0; i < inputs.size(); i++ ) delete inputs[i];
}


