#include "critterview.h"

Critterview::Critterview()
{
	critterselection = Critterselection::Instance();
	
	active = false;
	isMovable = true;

	v_width = 980;
	v_height = 350;
	
	position.x = 10;
	position.y = 50;

	currentCritter = 0;

	circuit8screenwidth = 64;
	circuit8screenheight = 48;

	// text widgets
	addWidgetText( "cv_cid", 10, 15, "Critter" );
// 	Widget* cid = addWidgetText( "cv_cid_c", 10, 15, "" );
	
	// view widgets
	viewbutton = addWidgetButton( "cv_view", Vector2i(10, 30), Vector2i(50, 50), "", Vector2i(0, 0), cmd.gen(""), 0, 0, 0 );
	vcortexbutton = addWidgetButton( "cv_cortex_visual", Vector2i(70, 30), Vector2i(settings->getCVar("critter_retinasize")+2, settings->getCVar("critter_retinasize")+2), "", Vector2i(0, 0), cmd.gen(""), 0, 0, 0 );
	pcortexbutton = addWidgetButton( "cv_cortex_psychic", Vector2i(70+(settings->getCVar("critter_retinasize"))+10, 30), Vector2i(circuit8screenwidth+2, circuit8screenheight+2), "", Vector2i(0, 0), cmd.gen(""), 0, 0, 0 );
	bviewbutton = addWidgetButton( "cv_bview", Vector2i(10, 90), Vector2i(v_width-20, v_height-100), "", Vector2i(0, 0), cmd.gen(""), 0, 0, 0 );
	children["cv_bview"]->isTransparant = false;

	unsigned int bwidth = 110;
	unsigned int bheight = 25;
	unsigned int bspacing = 4;
	
	unsigned int c_width = bspacing+150+(settings->getCVar("critter_retinasize"));
	unsigned int c_height = bspacing;
	addWidgetButton( "cv_autocam", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "follow cam", cmd.gen("follow_cv_crit"), 0, 0, 0 );

	c_width += bspacing + bwidth;
	c_height = bspacing;
	addWidgetButton( "cv_tripthis1", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "inhib antag", cmd.gen("tripthis1"), 0, 0, 0 );

	c_height += bspacing + bheight;
	addWidgetButton( "cv_tripthis2", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "inhib ag", cmd.gen("tripthis2"), 0, 0, 0 );

	c_height += bspacing + bheight;
	addWidgetButton( "cv_tripthis3", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "excit antag", cmd.gen("tripthis3"), 0, 0, 0 );

	c_width += bspacing + bwidth;
	c_height = bspacing;
	addWidgetButton( "cv_tripthis4", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "excit ag", cmd.gen("tripthis4"), 0, 0, 0 );

	c_height += bspacing + bheight;
	addWidgetButton( "cv_tripthis5", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "potentiator", cmd.gen("tripthis5"), 0, 0, 0 );

	c_height += bspacing + bheight;
	addWidgetButton( "cv_feedthis1", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "feed me", cmd.gen("feedthis1"), 0, 0, 0 );

	c_width += bspacing + bwidth;
	c_height = bspacing;
	addWidgetButton( "cv_togglelockblink1", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "un/blink main eye", cmd.gen("togglelockblink1"), 0, 0, 0 );

	c_height += bspacing + bheight;
	addWidgetButton( "cv_togglelockblink2", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "un/blink minds eye", cmd.gen("togglelockblink2"), 0, 0, 0 );

	c_height += bspacing + bheight;
	addWidgetButton( "cv_togglelockdruglevels", Vector2i(c_width, c_height), Vector2i(bwidth, bheight), "un/lock drug levels", cmd.gen("togglelockdruglevels"), 0, 0, 0 );

	for (int i = 0; i < settings->getCVar("critter_retinasize"); i++) {
		for (int j = 0; j < settings->getCVar("critter_retinasize"); j++) {
			for (int k = 0; k <= 3; k++) {
//				vcortex[i][j][k] = -1;
				vcortex[i][j][k] = 0;
			}
		}
	}
	
	for (int i = 0; i < 64; i++) {
		for (int j = 0; j < 48; j++) {
			for (int k = 0; k < 3; k++) {
				pcortex[i][j][k] = -1;
			}
		}
	}
	


//	vcortexptr = *vcortex;
}

void Critterview::draw()
{
	int v_radius = 4;
	int v_diam = 2*v_radius;
	int spacing = 3;
	int column = 0;
	int row = 0;
	int rowlength = 88;

	if ( critterselection->selectedCritter == 0 )
	{
		active = false;
		currentCritter = 0;
	}
	else
	{
		active = true;
		if ( critterselection->selectedCritter != currentCritter )
		{
			glBegin(GL_POINTS);
			for (int i = 0; i < 64; i++) {
				for (int j = 0; j < 48; j++) {
					for (int c = 0; c < 3; c++) {
						pcortex[i][j][c]=0;
					}
					glColor3f (0, 0, 0);
					glVertex2f(pcortexbutton->absPosition.x+i+1, pcortexbutton->absPosition.y+j+1);
				}
			}

/*			for (int i = 0; i < settings->getCVar("critter_retinasize"); i++) {
				for (int j = 0; j < settings->getCVar("critter_retinasize"); j++) {
					for (int c = 0; c <= 3; c++) {
						vcortex[i][j][c]=0;
					}
					glColor3f (0, 0, 0);
					glVertex2f(vcortexbutton->absPosition.x+i+1, vcortexbutton->absPosition.y+j+1);
					
				}
			}  */
			
			glEnd();

			currentCritter = critterselection->selectedCritter;

			sensors.clear();
			for ( unsigned int i=0; i < currentCritter->brain.numberOfInputs; i++ )
			{
				sensor s;
				s.sPointer = &currentCritter->brain.Inputs[i];
				int woffset = v_radius+((spacing+v_diam)*column);
				int hoffset = v_radius+((spacing+v_diam)*row);
				s.position = Vector2f(woffset, hoffset);
				sensors.push_back(s);

				if ( ++column == rowlength ) { column = 0; row++; }
			}

			//row = (currentCritter->brain.numberOfInputs/rowlength) + 1;
			row = 2; // flamoot
			neurons.clear();
			for ( unsigned int i=0; i < currentCritter->brain.totalNeurons; i++ )
			{
				neuron n;
				n.nPointer = &currentCritter->brain.Neurons[i];
				n.anPointer = &currentCritter->brain.ArchNeurons[i]; // flamoot and does this work
				int woffset = v_radius+((spacing+v_diam)*column);
				int hoffset = v_radius+((spacing+v_diam)*row);
				n.position = Vector2f(woffset, hoffset);
				neurons.push_back(n);

				if ( ++column == rowlength ) { column = 0; row++; }
			}
		}
	}

	if (active)
	{
		drawBackground();
		drawBorders();
		// draw the rest
		drawChildren();
		textprinter->print( bviewbutton->absPosition.x+100, absPosition.y+15, critterselection->selectedCritter->critterID );

		// draw gl view
//		if (!critterselection->selectedCritter->blink && !critterselection->selectedCritter->lockblink) {
			glViewport(viewbutton->absPosition. x, *settings->winHeight-50-viewbutton->absPosition.y, 50, 50);
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			glFrustum( -0.05f, 0.05f,-0.05f,0.05f, 0.1f, 10000.0f);
			critterselection->selectedCritter->body.mouths[0]->ghostObject->getWorldTransform().inverse().getOpenGLMatrix(viewposition);
			glMultMatrixf(viewposition);


//  			Displaylists::Instance()->glMultiMatrix(viewposition);

			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();

			world->drawWithinCritterSight(critterselection->selectedCritter);

		// switch back to 2d 
			world->camera.place();
			glPushMatrix();
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			glOrtho(0, *settings->winWidth, *settings->winHeight, 0, 0, 1);
			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
//		}
		
		// drift
			// neuron vs neuron
// flamoot (this is slow so i comment it out at least sometimes)
/*			for ( unsigned int i=0; i < neurons.size()-1; i++ )
				for ( unsigned int j=i+1; j < neurons.size(); j++ )
				{
					// how many connections do they have underling
					unsigned int nrlinks = 0;
					for ( unsigned int k=0; k < currentCritter->brain.ArchNeurons[i].ArchSynapses.size(); k++ )
					{
						ArchSynapse* as = &currentCritter->brain.ArchNeurons[i].ArchSynapses[k];
						if ( !as->isSensorNeuron && as->neuronID == j )
							nrlinks++;
					}
					for ( unsigned int k=0; k < currentCritter->brain.ArchNeurons[j].ArchSynapses.size(); k++ )
					{
						ArchSynapse* as = &currentCritter->brain.ArchNeurons[j].ArchSynapses[k];
						if ( !as->isSensorNeuron && as->neuronID == i )
							nrlinks++;
					}
					float xD=neurons[j].position.x - neurons[i].position.x;
					float yD=neurons[j].position.y - neurons[i].position.y;
					float dist = sqrt((xD*xD)+(yD*yD));
					float oneoverdistancesquared = 1.0f/(dist*dist);
					if ( oneoverdistancesquared > 1000.0f )
						oneoverdistancesquared = 1000.0f;
					if ( nrlinks > 0 )
					{
// 						if ( dist > 3 )
// 						{
						neurons[i].position.x += (xD / 5000.0f) * dist * nrlinks;
						neurons[i].position.y += (yD / 5000.0f) * dist * nrlinks;

						neurons[j].position.x -= (xD / 5000.0f) * dist * nrlinks;
						neurons[j].position.y -= (yD / 5000.0f) * dist * nrlinks;
// 						}
					}
					else
					{
/*							neurons[i].position.x -= (xD / 1.0f) * oneoverdistancesquared;
						neurons[i].position.y -= (yD / 1.0f) * oneoverdistancesquared;

						neurons[j].position.x += (xD / 1.0f) * oneoverdistancesquared;
						neurons[j].position.y += (yD / 1.0f) * oneoverdistancesquared;* //flamoot (add /)
					}
					// general antigravity
					neurons[i].position.x -= (xD * 10.0f) * oneoverdistancesquared;
					neurons[i].position.y -= (yD * 10.0f) * oneoverdistancesquared;

					neurons[j].position.x += (xD * 10.0f) * oneoverdistancesquared;
					neurons[j].position.y += (yD * 10.0f) * oneoverdistancesquared;

					//distance=sqrt(xD*xD+yD*yD);
					float miny = v_radius+((spacing+v_diam) * ((sensors.size()/rowlength)+1) );
					if ( neurons[i].position.x+v_radius > *bviewbutton->v_widthP ) neurons[i].position.x = *bviewbutton->v_widthP-v_radius;
					if ( neurons[i].position.x < v_radius ) neurons[i].position.x = v_radius;
					if ( neurons[i].position.y+v_radius > *bviewbutton->v_heightP ) neurons[i].position.y = *bviewbutton->v_heightP-v_radius;
					if ( neurons[i].position.y < miny ) neurons[i].position.y = miny;

					if ( neurons[j].position.x+v_radius > *bviewbutton->v_widthP ) neurons[j].position.x = *bviewbutton->v_widthP-v_radius;
					if ( neurons[j].position.x < v_radius ) neurons[j].position.x = v_radius;
					if ( neurons[j].position.y+v_radius > *bviewbutton->v_heightP ) neurons[j].position.y = *bviewbutton->v_heightP-v_radius;
					if ( neurons[j].position.y < miny ) neurons[j].position.y = miny;
				}
*/
		
/*			// neuron vs sensor
			for ( unsigned int i=0; i < neurons.size(); i++ )
				for ( unsigned int j=0; j < sensors.size(); j++ )
				{
					// how many connections do they have underling
					unsigned int nrlinks = 0;
					for ( unsigned int k=0; k < currentCritter->brain.ArchNeurons[i].ArchSynapses.size(); k++ )
					{
						ArchSynapse* as = &currentCritter->brain.ArchNeurons[i].ArchSynapses[k];
						if ( as->isSensorNeuron && as->realneuronID == j )
							nrlinks++;
					}
					float xD=sensors[j].position.x - neurons[i].position.x;
					float yD=sensors[j].position.y - neurons[i].position.y;
					float dist = sqrt((xD*xD)+(yD*yD));
					float oneoverdistancesquared = 1.0f/(dist*dist*dist);
					if ( oneoverdistancesquared > 1.0f )
						oneoverdistancesquared = 1.0f;
					if ( nrlinks > 0 )
					{
						neurons[i].position.x += (xD / 1000.0f) * dist * nrlinks;
						neurons[i].position.y += (yD / 1000.0f) * dist * nrlinks;
					}
					// general antigravity
					neurons[i].position.x -= xD * oneoverdistancesquared * 1000;
					neurons[i].position.y -= yD * oneoverdistancesquared * 1000;

					//distance=sqrt(xD*xD+yD*yD);
					float miny = v_radius+((spacing+v_diam) * ((sensors.size()/rowlength)+1) );
					if ( neurons[i].position.x+v_radius > *bviewbutton->v_widthP ) neurons[i].position.x = *bviewbutton->v_widthP-v_radius;
					if ( neurons[i].position.x < v_radius ) neurons[i].position.x = v_radius;
					if ( neurons[i].position.y+v_radius > *bviewbutton->v_heightP ) neurons[i].position.y = *bviewbutton->v_heightP-v_radius;
					if ( neurons[i].position.y < miny ) neurons[i].position.y = miny;
				} */ // to slow flamoot

		// draw brain
			// connections
// below is also too slow, flamoot but leave commented lines commented if you uncomment this block
/*
			glBegin(GL_LINES);
// 			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
			for ( unsigned int i=0; i < neurons.size(); i++ )
			{
// 				if ( neurons[i].nPointer->output )
// 				{
// 					if ( neurons[i].nPointer->isMotor )
// 						glColor4f(0.0f, 0.0f, 0.5f, 1.0f);
// 					else if ( neurons[i].nPointer->isInhibitory )
// 						glColor4f(0.5f, 0.0f, 0.0f, 1.0f);
// 					else
// 						glColor4f(0.0f, 0.5f, 0.0f, 1.0f);
// 				}
// 				else
// 				{
// 					if ( neurons[i].nPointer->isMotor )
// 						glColor4f(0.0f, 0.0f, dimmed, 1.0f);
// 					else if ( neurons[i].nPointer->isInhibitory )
// 						glColor4f(dimmed, 0.0f, 0.0f, 1.0f);
// 					else
// 						glColor4f(0.0f, dimmed, 0.0f, 1.0f);
// 				}

					for ( unsigned int j=0; j < currentCritter->brain.ArchNeurons[i].ArchSynapses.size(); j++ )
					{
						//break; // flamoot -- everything is too slow
						ArchSynapse* as = &currentCritter->brain.ArchNeurons[i].ArchSynapses[j];
						if ( !as->isSensorNeuron && currentCritter->brain.Neurons[as->neuronID].output || as->isSensorNeuron && currentCritter->brain.Inputs[as->realneuronID].output )
						{
							if ( as->isSensorNeuron ) {
								// continue; // flamoot -- too many in leghacked foodotropes
								glColor4f(0.0f, 0.4f, 0.4f, 1.0f); // flamoot (its cyan)
							}
							else if ( !neurons[as->neuronID].nPointer->isInhibitory )
								glColor4f(0.0f, 0.4f, 0.0f, 1.0f);
							else
								glColor4f(0.4f, 0.0f, 0.0f, 1.0f);

							glVertex2f(neurons[i].position.x+bviewbutton->absPosition.x,         neurons[i].position.y+bviewbutton->absPosition.y);
							if ( as->isSensorNeuron )
							{
								glVertex2f(bviewbutton->absPosition.x+sensors[as->realneuronID].position.x,         bviewbutton->absPosition.y+sensors[as->realneuronID].position.y);
							}
							else
							{
								glVertex2f(bviewbutton->absPosition.x+neurons[as->neuronID].position.x,         bviewbutton->absPosition.y+neurons[as->neuronID].position.y);
							}
						}
					}
// 				} 
			}
			glEnd(); */

                        // clear cortex views
                        //glBegin(GL_POINTS);
                        for (int i = 0; i < 64; i++) {
                                for (int j = 0; j < 48; j++) {
                                        for (int c = 0; c < 3; c++) {
                                                pcortex[i][j][c]=-1;  
                                        }
                                        //glColor3f (0, 0, 0);
                                        //glVertex2f(pcortexbutton->absPosition.x+i+1, pcortexbutton->absPosition.y+j+1);
                                }                                                                                      
                        }

                        for (int i = 0; i < settings->getCVar("critter_retinasize"); i++) {
                                for (int j = 0; j < settings->getCVar("critter_retinasize"); j++) {
                                        for (int c = 0; c <= 3; c++) {                              
//                                                vcortex[i][j][c]=-1;
//                                                vcortex[i][j][c] *= 0.8f; // attempt at fade to try to show firing rate
						if (vcortex[i][j][c]>=0.1f) vcortex[i][j][c] -= 0.1f; // try at fade for rate out of 100 frames
                                        }
                                        //glColor3f (0, 0, 0);
                                        //glVertex2f(vcortexbutton->absPosition.x+i+1, vcortexbutton->absPosition.y+j+1);
                                                                                                                       
                                }       
                        }
                        //glEnd();


			// render visual cortex view
			int colourchannel = 0;
			int retinaloffset = 0;
			int cortexcol = 0;
			int cortexrow = 0;
			int retsize = 0;
//			int brite = 0;
			retsize = settings->getCVar("critter_retinasize");
//			quadretsize = retsize * 4; // should use shift left always for mults by powers of 2 but i forget how atm
//			GLfloat glci[3];
			for ( unsigned int i=0; i < neurons.size()-1; i++ ) {
				for ( unsigned int k=0; k < currentCritter->brain.ArchNeurons[i].ArchSynapses.size(); k++ ) {
					ArchSynapse* as = &currentCritter->brain.ArchNeurons[i].ArchSynapses[k];
					if ( as->isSensorNeuron && as->neuronID >= 50000 && as->neuronID < 100000) {
						colourchannel = (as->neuronID - 50000) % 4;
						retinaloffset = ((as->neuronID - colourchannel) - 50000) / 4;
//						cout << "colourchannel = " << colourchannel << endl;
//						cout << "retinaloffset = " << retinaloffset << endl;
						cortexcol = retinaloffset % retsize;
						cortexrow = (retsize - 1) - (retinaloffset - cortexcol) / retsize; // upside down
//						cout << "cortexcol = " << cortexcol << endl;
//						cout << "cortexrow = " << cortexrow << endl;
						//glReadPixels(vcortexbutton->absPosition.x+cortexcol, vcortexbutton->absPosition.y+cortexrow, 1, 1, GL_RGB, GL_FLOAT, glci);
						//cout << glci[0] << " " << glci[1] << " " << glci[2] << " " << glci[3] << endl;
//						glColor3f (1.0f, 1.0f, 1.0f);

/*						if (vcortex[cortexcol][cortexrow][colourchannel] != -1) {
							vcortex[cortexcol][cortexrow][colourchannel] = (vcortex[cortexcol][cortexrow][colourchannel] + (currentCritter->brain.Neurons[i].potential / currentCritter->brain.Neurons[i].firingThreshold)) / 2;
						} else { 
							vcortex[cortexcol][cortexrow][colourchannel] = (currentCritter->brain.Neurons[i].potential / currentCritter->brain.Neurons[i].firingThreshold);
						} */
						if (currentCritter->brain.Neurons[i].output) {
							float t = vcortex[cortexcol][cortexrow][colourchannel];
							t += 0.15f;
							if (t > 1.0f) {t = 1.0f;}
							vcortex[cortexcol][cortexrow][colourchannel] = t;
						}
					}
				}
			}

			glBegin(GL_POINTS);
			for (int i = 0; i < retsize; i++) {
				for (int j = 0; j < retsize; j++) {
					float vcr = vcortex[i][j][0];
					float vcg = vcortex[i][j][1];
					float vcb = vcortex[i][j][2];
					float vca = vcortex[i][j][3];
					if (vca > 0) { // show alpha as whiteness
//						vcr += vca*2.0f;
//						vcg += vca*2.0f;
//						vcb += vca*2.0f;
						vcr *= vca*1.25f;
						vcg *= vca*1.25f;
						vcb *= vca*1.25f;
						if (vcr > 1.0f) {vcr=1.0f;}
						if (vcg > 1.0f) {vcg=1.0f;}
						if (vcb > 1.0f) {vcb=1.0f;}
					}
					glColor3f (vcr, vcg, vcb);
					glVertex2f(vcortexbutton->absPosition.x+i+1, vcortexbutton->absPosition.y+j+1);
				}
			}
			glEnd();


			// render psychic cortex view
			for ( unsigned int i=0; i < neurons.size()-1; i++ ) {
				for ( unsigned int k=0; k < currentCritter->brain.ArchNeurons[i].ArchSynapses.size(); k++ ) {
					ArchSynapse* as = &currentCritter->brain.ArchNeurons[i].ArchSynapses[k];
					if ( as->isSensorNeuron && as->neuronID >= 100000 && as->neuronID < 500000) {
						colourchannel = (as->neuronID - 100000) % 3;// only 3 colour channels on psychic screen 
						retinaloffset = ((as->neuronID - colourchannel) - 100000) / 3;
//						cout << "colourchannel = " << colourchannel << endl;
//						cout << "retinaloffset = " << retinaloffset << endl;
						cortexcol = retinaloffset % 64;
						cortexrow = ( 48 - 1) - ((retinaloffset - cortexcol) / 64); //upside down
//						cout << "cortexcol = " << cortexcol << endl;
//						cout << "cortexrow = " << cortexrow << endl;
						//glReadPixels(vcortexbutton->absPosition.x+cortexcol, vcortexbutton->absPosition.y+cortexrow, 1, 1, GL_RGB, GL_FLOAT, glci);
						//cout << glci[0] << " " << glci[1] << " " << glci[2] << " " << glci[3] << endl;
//						glColor3f (1.0f, 1.0f, 1.0f);

//						pcortex[cortexcol][cortexrow][colourchannel] = (pcortex[cortexcol][cortexrow][colourchannel] + (currentCritter->brain.Neurons[i].potential / currentCritter->brain.Neurons[i].firingThreshold)) / 2;
						if (pcortex[cortexcol][cortexrow][colourchannel] != -1) {
							pcortex[cortexcol][cortexrow][colourchannel] = (pcortex[cortexcol][cortexrow][colourchannel] + (currentCritter->brain.Neurons[i].potential / currentCritter->brain.Neurons[i].firingThreshold)) / 2;
						} else { 
							pcortex[cortexcol][cortexrow][colourchannel] = (currentCritter->brain.Neurons[i].potential / currentCritter->brain.Neurons[i].firingThreshold);
						}

						
					}
				}
			}

			glBegin(GL_POINTS);
			for (int i = 0; i < 64; i++) {
				for (int j = 0; j < 48; j++) {
					glColor3f (pcortex[i][j][0], pcortex[i][j][1], pcortex[i][j][2]);
					glVertex2f(pcortexbutton->absPosition.x+i+1, pcortexbutton->absPosition.y+j+1);
				}
			}
			glEnd();

			glBegin(GL_QUADS);

			float dimmed = 0.3f;
			// inputs
			unsigned int tmp = sensors.size() - currentCritter->body.archConstraints.size();
			for ( unsigned int i=0; i < sensors.size(); i++ )
			{
				if (i>23 && i<tmp) { i = tmp; } // to slow flamoot

//				if ( sensors[i].sPointer->output )
//					glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
//				else
//					glColor4f(0.0f, dimmed, 0.0f, 1.0f);
//				cout << sensors[i].sPointer->output << endl;

				glColor4f(0.0f, sensors[i].sPointer->output, 0.0f, 1.0f);

// 				glScaled(sensors[i].sPointer->output, sensors[i].sPointer->output, sensors[i].sPointer->output);
// 				cerr << sensors[i].sPointer->output <<  endl;

// 				float nv_radius = sensors[i].sPointer->output * v_radius;
				float nv_radius = v_radius;

				int tmpp;
				if (i>23) {tmpp = (i - tmp) + 26; } else {tmpp = i;}
				
				glVertex2f(sensors[tmpp].position.x+bviewbutton->absPosition.x-nv_radius, sensors[tmpp].position.y+bviewbutton->absPosition.y+nv_radius);
				glVertex2f(sensors[tmpp].position.x+bviewbutton->absPosition.x-nv_radius, sensors[tmpp].position.y+bviewbutton->absPosition.y-nv_radius);
				glVertex2f(sensors[tmpp].position.x+bviewbutton->absPosition.x+nv_radius, sensors[tmpp].position.y+bviewbutton->absPosition.y-nv_radius);
				glVertex2f(sensors[tmpp].position.x+bviewbutton->absPosition.x+nv_radius, sensors[tmpp].position.y+bviewbutton->absPosition.y+nv_radius);
			}

			// neurons
			for ( unsigned int i=0; i < neurons.size(); i++ )
			{
				float neuralred = 0.0f;
				float neuralgreen = 0.0f;
				float neuralblue = 0.0f; // flamoot

				if ( neurons[i].anPointer->hasConsistentSynapses ) {
					neuralblue += 0.2f; // tryna figure out what this lavender one is
				}

				if ( neurons[i].anPointer->motorID == 500000 ) { // flamoot (eat)
					neuralred = 0.3f;
					neuralblue = 0.3f;
					neuralgreen = 0.3f;
				}
				else if ( neurons[i].anPointer->motorID == 500001 ) { // flamoot (breed)
					neuralred = 0.6f;
					neuralblue = 0.6;
					neuralgreen = 0.6f;
				}
				else if ( neurons[i].nPointer->isPlastic ) { // flamoot
						neuralgreen += (neurons[i].anPointer->plasticityWeaken - currentCritter->brain.minPlasticityWeaken) / (currentCritter->brain.maxPlasticityWeaken+0.1f - currentCritter->brain.minPlasticityWeaken);
						neuralred += (neurons[i].anPointer->plasticityStrengthen - currentCritter->brain.minPlasticityStrengthen) / (currentCritter->brain.maxPlasticityStrengthen+0.1f - currentCritter->brain.minPlasticityStrengthen);
//						cout << neuralred;
						if ( neuralred > 1.0f ) neuralred = 1.0f;
						if ( neuralgreen > 1.0f) neuralgreen = 1.0f;
						neuralblue += 0.1f;
						// glColor4f(neuralred, neuralgreen, neuralblue+0.1f, 1.0f);
				}
				
// 				if ( neurons[i].nPointer->output )
// 				{
					if ( neurons[i].nPointer->isMotor ) {
						neuralblue += 0.9f;
						if ( neuralblue > 1 ) { neuralblue = 1; }
						glColor4f(neuralred, neuralgreen, neuralblue, 1.0f);
						}
					else if ( neurons[i].nPointer->isInhibitory ) {
						neuralred /= 2;
						neuralgreen /= 2;
						neuralblue /= 2;
						neuralred += .5;
						if ( neuralred > 1 ) { neuralred = 1; }
						glColor4f(neuralred, neuralgreen, neuralblue, 1.0f);
					}
					else {
						if ( !neurons[i].nPointer->isPlastic ) {
							neuralred /= 2;
							neuralgreen /= 2;
							neuralblue /= 2;
							neuralgreen += .5;
							if ( neuralgreen > 1 ) { neuralgreen = 1; }
						} else {
							// flamoot
						}
						glColor4f(neuralred, 1.0f, neuralblue, 1.0f);
					}
// 				}
// 				else
// 				{
// 					if ( neurons[i].nPointer->isMotor )
// 						glColor4f(0.0f, 0.0f, dimmed, 1.0f);
// 					else if ( neurons[i].nPointer->isInhibitory )
// 						glColor4f(dimmed, 0.0f, 0.0f, 1.0f);
// 					else
// 						glColor4f(0.0f, dimmed, 0.0f, 1.0f);
// 				}

//				float nv_radius = (neurons[i].nPointer->potential * v_diam) / settings->getCVar("brain_maxfiringthreshold");
				float nv_radius = 0;
				if ( neurons[i].nPointer->output ) {
					glColor4f(0.8f, 0.8f, 0.8f, 0.8f);
					nv_radius = v_diam-4;
				} else {
					nv_radius = (neurons[i].nPointer->potential * v_diam) / neurons[i].nPointer->firingThreshold;
				}
				glVertex2f(neurons[i].position.x+bviewbutton->absPosition.x-nv_radius, neurons[i].position.y+bviewbutton->absPosition.y+nv_radius);
				glVertex2f(neurons[i].position.x+bviewbutton->absPosition.x-nv_radius, neurons[i].position.y+bviewbutton->absPosition.y-nv_radius);
				glVertex2f(neurons[i].position.x+bviewbutton->absPosition.x+nv_radius, neurons[i].position.y+bviewbutton->absPosition.y-nv_radius);
				glVertex2f(neurons[i].position.x+bviewbutton->absPosition.x+nv_radius, neurons[i].position.y+bviewbutton->absPosition.y+nv_radius);
			}

	// 		// outputs
	// 		column = 0;
	// 		for ( unsigned int i=0; i < currentCritter->brain.numberOfOutputs; i++ )
	// 		{
	// 			if ( *currentCritter->brain.Outputs[i].output )
	// 				glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
	// 			else
	// 				glColor4f(0.0f, 0.0f, dimmed, 1.0f);
	// 
	// 			int woffset = v_radius+((spacing+v_diam)*column);
	// 			int hoffset = 250-v_height;
	// 			glVertex2f(bviewbutton->absPosition.x+woffset-v_radius, bviewbutton->absPosition.y+hoffset+v_radius);
	// 			glVertex2f(bviewbutton->absPosition.x+woffset-v_radius, bviewbutton->absPosition.y+hoffset-v_radius);
	// 			glVertex2f(bviewbutton->absPosition.x+woffset+v_radius, bviewbutton->absPosition.y+hoffset-v_radius);
	// 			glVertex2f(bviewbutton->absPosition.x+woffset+v_radius, bviewbutton->absPosition.y+hoffset+v_radius);
	// 			
	// 			if ( ++column == rowlength ) { column = 0; row++; }
	// 		}

			glEnd();

	}
	
}

Critterview::~Critterview()
{
}
